<template>
  <section-container title="Sandbox">
    <api-data endpoint="/auth/" v-model="userInfo" />
    <api-data endpoint="/project/transformation/" v-model="transformations" />
    <h4>
      <code>{{ userInfo.sandbox_name }}</code>
    </h4>
    To download your credentials, see the
    <a :href="`${base_url}vault/${userInfo.sandbox_name}`">Vault</a>.
  </section-container>
  <section-container title="Load data">
    <div class="form-group">
      <label for="load-transformation"
        >Load transformation's input mapping</label
      >
      <select
        id="load-transformation"
        class="form-control"
        @change="transformationId = $event.target.value"
      >
        <option value="--none--" selected>&lt;none&gt;</option>
        <option
          v-for="info in transformationsSorted"
          :key="info.id"
          :value="info.id"
        >
          {{ info.id }}
        </option>
      </select>
    </div>
    <div class="form-group my-3">
      <button
        type="button"
        class="btn btn-primary"
        @click="showExplorer = true"
      >
        <i class="fas fa-plus"></i> Additional tables...
      </button>
    </div>
    <storage-selector v-if="showExplorer" multiple @select="closeExplorer" />
    <div class="form-check">
      <input
        class="form-check-input"
        type="checkbox"
        id="load-clean"
        v-model="loadClean"
      />
      <label class="form-check-label" for="load-clean">
        Clean sandbox (drop all tables)
      </label>
    </div>
    <div class="form-check">
      <input
        class="form-check-input"
        type="checkbox"
        id="load-run"
        v-model="loadRun"
        :disabled="transformationId === '--none--'"
      />
      <label class="form-check-label" for="load-run">
        Run selected transformation
      </label>
    </div>
    <div class="form-group" v-if="transformationId !== '--none--' && loadRun">
      <label for="load-run-until"> Run transformation until </label>
      <select
        name="load-run-until"
        id="load-run-until"
        class="form-control"
        :key="transformationId"
        v-model="runUntil"
      >
        <option
          v-for="(fname, index) in selectedTransformation?.files || []"
          :key="fname"
          :selected="index === selectedTransformation?.files?.length - 1"
          :value="fname"
        >
          {{ fname
          }}<template
            v-if="index === selectedTransformation?.files?.length - 1"
          >
            (last file)</template
          >
        </option>
      </select>
    </div>
    <hr />
    <h4>Input:</h4>
    <template v-if="transformationId !== '--none--'">
      <h5>
        From transformation <code>{{ transformationId }}</code>
      </h5>
      <ul>
        <li v-for="kex in selectedTransformation?.input_kexes" :key="kex.kex">
          <a :href="`${base_url}storage/${kex.kex}`">{{ kex.kex }}</a>
        </li>
        <li
          v-for="table in selectedTransformation?.input_tables"
          :key="table.kex.kex + table.table"
        >
          <a :href="`${base_url}storage/${table.kex.kex}/${table.table}`"
            >{{ table.kex.kex }}.{{ table.table }}</a
          >
        </li>
      </ul>
    </template>
    <template v-if="additionalInput.length !== 0">
      <h5>Additional input</h5>
      <ul>
        <li v-for="table in additionalInput" :key="table">
          <a :href="`${base_url}storage/${table.kex}/${table.table}`"
            >{{ table.kex }}.{{ table.table }}</a
          >
        </li>
      </ul>
    </template>
    <div class="alert alert-danger" v-if="loadClean">
      <i class="fas fa-exclamation-triangle"></i> All tables will be dropped
      from the sandbox
    </div>
    <button class="btn btn-success" type="button" @click="loadSandbox">
      Load sandbox
    </button>
  </section-container>
</template>

<script>
export default {
  name: "Sandbox",
  data() {
    return {
      userInfo: {},
      transformations: [],
      transformationId: "--none--",
      loadRun: false,
      transformationInput: [],
      additionalInput: [],
      showExplorer: false,
      loadClean: false,
      runUntil: null,
    };
  },
  methods: {
    loadSandbox() {
      const transid =
        this.transformationId === "--none--" ? null : this.transformationId;
      let payload = {
        clean: this.loadClean,
        transformation_id: transid,
        run: this.loadRun,
        run_until: this.runUntil,
        additional_tables: this.additionalInput.map(({ kex, table }) => {
          return { table, kex: { kex } };
        }),
      };
      const url =
        `${this.apiUrl}/sandbox/${this.userInfo.sandbox_name}`.replace(
          "{origin}",
          window.location.origin
        );
      // TODO: Refactor into a POST / PUT component

      import("axios").then(({ default: axios }) => {
        axios.interceptors.response.use(
          (response) => response,
          (error) => {
            if (typeof error.response === "undefined") {
              this.notify(
                "A network error occurred. " +
                  "This could be a CORS issue or a dropped internet connection. " +
                  "It is not possible for us to know.",
                "Network error",
                "error"
              );
            }
            return Promise.reject(error);
          }
        );
        axios
          .put(url, payload, { withCredentials: true })
          .then(() =>
            this.notify(
              "Sandbox load should start in a minute",
              "Load triggered",
              "success"
            )
          )
          .catch((error) =>
            this.notify(
              error || "Unexpected error ocurred",
              error?.name || "Error",
              "error"
            )
          );
      });
    },
    closeExplorer(tables) {
      this.showExplorer = false;
      if (tables === null) return;
      let input = [];
      for (const kex in tables) {
        input = input.concat(
          tables[kex].map((table) => {
            return { kex, table };
          })
        );
      }
      this.additionalInput = input;
    },
  },
  computed: {
    selectedTransformation() {
      const selected = this.transformations.filter(
        (info) => info.id === this.transformationId
      );
      if (selected.length === 0) return null;
      return selected[0];
    },
    transformationsSorted() {
      const copy = Array.from(this.transformations);
      copy.sort((a, b) => (a.id < b.id ? -1 : a.id == b.id ? 0 : 1));
      return copy;
    },
  },
};
</script>

<style></style>
